package praktikum01;

//Zahlenfilter
public class Zahlenfilter {

    private int start;

    private int end;

    public Zahlenfilter(int s, int e){
        start = s;
        end = e;
    }
    public static void main(String[] args) {
        // Standardendwert ist 200, falls keine Argumente übergeben werden
        int end = 200;

        // Überprüfen, ob ein Programmargument übergeben wurde
        if (args.length > 0) {
            try {
                // Versuchen, das Argument in eine Zahl umzuwandeln
                end = Integer.parseInt(args[0]);
            } catch (NumberFormatException e) {
                // Fehlermeldung, wenn das Argument keine gültige Zahl ist
                System.out.println("Fehler: Bitte eine gültige Zahl als Programmargument eingeben.");
                return; // Programm beenden
            }
        }

        Zahlenfilter zf = new Zahlenfilter (1, end);
        zf.countUp();
    }

    private void countUp(){
        for (int i = 1; i <= end; i++) {
            checkDivByFive(i);
            checkEndsWithNine(i);
            checkSumDivByThree(i);
        }
    }

    private void checkDivByFive (int number){
        // Wenn durch 5 Teilbar
        if (number % 5 == 0) {
            System.out.println(number + " - ist durch 5 Teilbar");
        }
    }
    private void checkEndsWithNine (int number){
        // Wenn Zahl auf 9 endet
        if (number % 10 == 9) {
            System.out.println(number + " - endet auf 9");
        }
    }

    private void checkSumDivByThree (int number){
        int vorgaenger = number - 1;
        int summe = number + vorgaenger;


        // Überprüfen, ob die Summe durch 3 teilbar ist
        if (summe % 3 == 0) {
            System.out.println(number + " und " + vorgaenger + " addiert ergeben " + summe + "; " +"ist durch 3 teilbar.");
        }
    }
}